import { defineComponent as S, ref as x, onMounted as j, markRaw as T, watch as $, unref as k, openBlock as b, createElementBlock as E, computed as I, nextTick as K, shallowRef as Q, getCurrentInstance as X, onBeforeUnmount as Y, normalizeClass as ee, normalizeStyle as te, createBlock as ne, resolveDynamicComponent as oe, mergeProps as re } from "vue";
import "codemirror/lib/codemirror.css";
import "codemirror/addon/fold/foldgutter.css";
import "codemirror/addon/fold/foldcode.js";
import "codemirror/addon/fold/foldgutter.js";
import "codemirror/addon/fold/brace-fold.js";
import "codemirror/addon/selection/active-line.js";
import R from "codemirror";
import "codemirror/addon/merge/merge.css";
import "codemirror/addon/merge/merge.js";
import se from "diff-match-patch";
import "codemirror/addon/mode/simple.js";
!window.CodeMirror && (window.CodeMirror = R);
const _ = window.CodeMirror || R, ae = S({
  name: "DefaultMode",
  props: {
    name: {
      type: String,
      default: `cm-textarea-${+/* @__PURE__ */ new Date()}`
    },
    value: {
      type: String,
      default: ""
    },
    content: {
      type: String,
      default: ""
    },
    options: {
      type: Object,
      default: () => ({})
    },
    cminstance: {
      type: Object,
      default: () => null
    },
    placeholder: {
      type: String,
      default: ""
    }
  },
  emits: {
    ready: (e) => e,
    "update:cminstance": (e) => e
  },
  setup(e, { emit: n }) {
    const r = x(), t = x(null), o = () => {
      t.value = T(_.fromTextArea(r.value, e.options)), n("update:cminstance", t.value);
      const s = $(
        () => e.cminstance,
        (l) => {
          var g;
          l && ((g = e.cminstance) == null || g.setValue(e.value || e.content)), n("ready", k(t)), s == null || s();
        },
        { deep: !0 }
      );
    };
    return j(() => {
      o();
    }), {
      textarea: r,
      initialize: o
    };
  }
}), A = (e, n) => {
  const r = e.__vccOpts || e;
  for (const [t, o] of n)
    r[t] = o;
  return r;
}, le = ["name", "placeholder"];
function ce(e, n, r, t, o, s) {
  return b(), E("textarea", {
    ref: "textarea",
    name: e.$props.name,
    placeholder: e.$props.placeholder
  }, null, 8, le);
}
const z = /* @__PURE__ */ A(ae, [["render", ce]]);
window.diff_match_patch = se;
window.DIFF_DELETE = -1;
window.DIFF_INSERT = 1;
window.DIFF_EQUAL = 0;
const ie = S({
  name: "MergeMode",
  props: {
    options: {
      type: Object,
      default: () => ({})
    },
    cminstance: {
      type: Object,
      default: () => ({})
    }
  },
  emits: ["update:cminstance", "ready"],
  setup(e, { emit: n }) {
    const r = x(), t = x(), o = () => {
      r.value = T(_.MergeView(t.value, e.options)), n("update:cminstance", r.value), n("ready", r);
    };
    return j(() => {
      o();
    }), {
      mergeView: t,
      initialize: o
    };
  }
}), ue = { ref: "mergeView" };
function de(e, n, r, t, o, s) {
  return b(), E("div", ue, null, 512);
}
const pe = /* @__PURE__ */ A(ie, [["render", de]]);
var me = /* @__PURE__ */ ((e) => (e.info = "info", e.warning = "warning", e.error = "error", e))(me || {});
function ge() {
  const e = /* @__PURE__ */ new Date(), n = e.getHours() < 10 ? `0${e.getHours()}` : e.getHours(), r = e.getMinutes() < 10 ? `0${e.getMinutes()}` : e.getMinutes(), t = e.getSeconds() < 10 ? `0${e.getSeconds()}` : e.getSeconds();
  return `${n}:${r}:${t}`;
}
function ze(e) {
  return `#link#${JSON.stringify(e)}#link#`;
}
function fe(e) {
  const n = /#link#(.+)#link#/g, r = [];
  let t;
  for (t = n.exec(e); t; ) {
    const o = document.createElement("a"), s = JSON.parse(t[1]), l = Object.entries(s);
    for (const [g, u] of l)
      o.setAttribute(g, u);
    o.className = "editor_custom_link", o.innerHTML = "logDownload", r.push({
      start: t.index,
      end: t.index + t[0].length,
      node: o
    }), t = n.exec(e);
  }
  return r;
}
function He(e = "", n = "info") {
  return `#log<${n}>log#${e}#log<${n}>log#`;
}
function he(e) {
  const n = [];
  function r() {
    const t = /#log<(\w*)>log#((.|\r\n|\n)*?)#log<(\w*)>log#/g;
    let o;
    for (o = t.exec(e); o; ) {
      const l = o[0].replace(/\r\n/g, `
`).split(`
`), u = o[2].replace(/\r\n/g, `
`).split(`
`), d = document.createElement("span"), c = o[1];
      d.className = `c-editor--log__${c}`;
      let p = 0;
      for (let a = 0; a < l.length; a++) {
        const m = l[a], v = u[a], y = d.cloneNode(!1);
        y.innerText = v, n.push({
          start: o.index + p,
          end: o.index + p + m.length,
          node: y
        }), p = p + m.length + 1;
      }
      o = t.exec(e);
    }
  }
  return r(), n;
}
function Re(e, n) {
  return `[${ge()}] <${n}> ${e}`;
}
function Be(e, n, r) {
  const o = new Array(Math.max(n || 15, 5)).join(r || "=");
  return `${o}${e}${o}`;
}
const M = [
  {
    regex: /(\[.*?\])([ \t]*)(<error>[ \t])(.+)/,
    token: ["tag", "", "error.strong", "error.strong"],
    sol: !0
    // next: "error",
  },
  {
    regex: /(\[.*?\])([ \t]*)(<info>)(.+)(.?)/,
    token: ["tag", "", "bracket", "bracket", "hr"],
    sol: !0
    // next: "info",
  },
  {
    regex: /(\[.*?\])([ \t]*)(<warning>)(.+)(.?)/,
    token: ["tag", "", "comment", "comment", "hr"],
    sol: !0
    // next: "warning",
  }
];
_.defineSimpleMode("fclog", {
  start: [
    ...M,
    {
      regex: /.*/,
      token: "hr"
    }
  ],
  error: [
    ...M,
    {
      regex: /.*/,
      token: "error.strong"
    }
  ],
  info: [
    ...M,
    {
      regex: /.*/,
      token: "bracket"
    }
  ],
  warning: [
    ...M,
    {
      regex: /.*\[/,
      token: "comment"
    }
  ]
});
_.defineSimpleMode("log", {
  start: [
    {
      regex: /^[=]+[^=]*[=]+/,
      token: "strong"
    },
    {
      regex: /([^\w])([A-Z][\w]*)/,
      token: ["", "string"]
    },
    {
      regex: /(^[A-Z][\w]*)/,
      token: "string"
    }
    // {
    //     regex: /([^\d])([0-9]+)/,
    //     token: [null, 'comment']
    // },
    // {
    //     regex: /(^[0-9]+)/,
    //     token: 'comment'
    // }
  ]
});
const ve = S({
  name: "CodemirrorFclog",
  props: {
    value: {
      type: String,
      default: ""
    },
    name: {
      type: String,
      default: `cm-textarea-${+/* @__PURE__ */ new Date()}`
    },
    options: {
      type: Object,
      default: () => ({})
    },
    cminstance: {
      type: Object,
      default: () => ({})
    },
    placeholder: {
      type: String,
      default: ""
    }
  },
  emits: ["update:cminstance", "ready"],
  setup(e, { emit: n }) {
    const r = x(), t = x(null), o = (l = e.cminstance) => {
      l.getAllMarks().forEach((c) => c.clear());
      const u = l.getValue(), d = [].concat(fe(u)).concat(he(u));
      for (let c = 0; c < d.length; c++) {
        const p = d[c];
        l.markText(l.posFromIndex(p.start), l.posFromIndex(p.end), {
          replacedWith: p.node
        });
      }
    }, s = () => {
      var l;
      t.value = T(_.fromTextArea(r.value, e.options)), n("update:cminstance", k(t)), (l = t.value) == null || l.on("change", o);
    };
    return $(
      () => e.cminstance,
      (l) => {
        var g;
        l && (o(e.cminstance), (g = e.cminstance) == null || g.setValue(e.value), n("ready", t));
      },
      { deep: !0, immediate: !0 }
    ), j(() => {
      s();
    }), {
      initialize: s,
      textarea: r
    };
  }
}), ye = ["name", "placeholder"];
function ke(e, n, r, t, o, s) {
  return b(), E("textarea", {
    ref: "textarea",
    name: e.$props.name,
    placeholder: e.$props.placeholder
  }, null, 8, ye);
}
const xe = /* @__PURE__ */ A(ve, [["render", ke]]), B = {
  "update:value": () => !0,
  change: (e, n) => ({ value: e, cm: n }),
  input: () => !0,
  ready: (e) => e
}, we = [
  "changes",
  "scroll",
  "beforeChange",
  "cursorActivity",
  "keyHandled",
  "inputRead",
  "electricInput",
  "beforeSelectionChange",
  "viewportChange",
  "swapDoc",
  "gutterClick",
  "gutterContextMenu",
  "focus",
  "blur",
  "refresh",
  "optionChange",
  "scrollCursorIntoView",
  "update"
], $e = () => {
  const e = {};
  return we.forEach((n) => {
    e[n] = (...r) => r;
  }), e;
}, _e = { ...B, ...$e() }, L = {
  mode: "text",
  // Language mode
  theme: "default",
  // Theme
  lineNumbers: !0,
  // Display line number
  smartIndent: !0,
  // Intelligent indentation
  indentUnit: 2,
  styleActiveLine: !0
};
function be(e) {
  Promise.resolve().then(() => {
    const n = e.getScrollInfo();
    e.scrollTo(n.left, n.height);
  });
}
const Ce = ({
  props: e,
  cminstance: n,
  emit: r,
  internalInstance: t,
  content: o
}) => {
  const s = I(
    () => {
      var u;
      return e.merge ? (u = k(n)) == null ? void 0 : u.editor() : k(n);
    }
  ), l = () => {
    const u = [];
    return Object.keys(t == null ? void 0 : t.vnode.props).forEach((d) => {
      if (d.startsWith("on")) {
        const c = d.replace(d[2], d[2].toLowerCase()).slice(2);
        !B[c] && u.push(c);
      }
    }), u;
  };
  return {
    listenerEvents: () => {
      s.value.on("change", (c) => {
        const p = c.getValue();
        p === o.value && p !== "" || (o.value = p, r("update:value", o.value || ""), r("input", o.value || " "), Promise.resolve().then(() => {
          r("change", o.value, c);
        }), e.keepCursorInEnd && be(c));
      });
      const u = {};
      l().filter((c) => !u[c] && (u[c] = !0)).forEach((c) => {
        s.value.on(c, (...p) => {
          r(c, ...p);
        });
      });
    }
  };
};
function Me({
  props: e,
  cminstance: n,
  presetRef: r
}) {
  const t = x("100%"), o = x("100%"), s = I(
    () => {
      var a;
      return e.merge ? (a = k(n)) == null ? void 0 : a.editor() : k(n);
    }
  ), l = () => {
    K(() => {
      var a;
      (a = s.value) == null || a.refresh();
    });
  }, g = (a = e.width, m = e.height) => {
    var C;
    let v = "100%", y = "100%";
    console.log("resize", a, a), typeof a == "number" ? v = `${String(a)}px` : a && (v = a), typeof m == "number" ? y = `${String(m)}px` : m && (y = m), t.value = v, o.value = y, console.log("resize", v, y), (C = s.value) == null || C.setSize("100%", "100%");
  }, u = () => {
    var m;
    const a = (m = s.value) == null ? void 0 : m.getWrapperElement();
    a == null || a.remove();
  }, d = () => {
    var m, v, y;
    const a = (m = s.value) == null ? void 0 : m.getDoc().getHistory();
    (v = r.value) == null || v.initialize(), u(), (y = s.value) == null || y.getDoc().setHistory(a);
  }, c = () => {
    const a = document.querySelector(
      ".CodeMirror-gutters"
    );
    return (a == null ? void 0 : a.style.left.replace("px", "")) !== "0";
  };
  return {
    reload: d,
    refresh: l,
    resize: g,
    destroy: u,
    containerWidth: t,
    containerHeight: o,
    reviseStyle: () => {
      if (l(), !c())
        return;
      const a = setInterval(() => {
        c() ? l() : clearInterval(a);
      }, 60), m = setTimeout(() => {
        clearInterval(a), clearTimeout(m);
      }, 400);
    }
  };
}
const H = /* @__PURE__ */ S({
  __name: "index",
  props: {
    value: {
      type: String,
      default: ""
    },
    options: {
      type: Object,
      default: () => L
    },
    globalOptions: {
      type: Object,
      default: () => L
    },
    placeholder: {
      type: String,
      default: ""
    },
    border: {
      type: Boolean,
      default: !1
    },
    width: {
      type: [String, Number],
      default: null
    },
    height: {
      type: [String, Number],
      default: null
    },
    originalStyle: {
      type: Boolean,
      default: !1
    },
    keepCursorInEnd: {
      type: Boolean,
      default: !1
    },
    merge: {
      type: Boolean,
      default: !1
    },
    name: {
      type: String,
      default: ""
    },
    marker: {
      type: Function,
      default: () => null
    },
    unseenLines: {
      type: Array,
      default: () => []
    }
  },
  emits: _e,
  setup(e, { expose: n, emit: r }) {
    var N, V, F;
    typeof Object.assign != "function" && Object.defineProperty(Object, "assign", {
      value(i) {
        if (i == null)
          throw new TypeError("Cannot convert undefined or null to object");
        const f = Object(i);
        for (let h = 1; h < arguments.length; h++) {
          const w = arguments[h];
          if (w != null)
            for (const O in w)
              Object.prototype.hasOwnProperty.call(w, O) && (f[O] = w[O]);
        }
        return f;
      },
      writable: !0,
      configurable: !0
    });
    const t = e, o = r, s = x(null), l = x(""), g = Q(z), u = x({
      foldGutter: !0,
      ...L,
      ...t.globalOptions,
      ...t.options,
      gutters: [.../* @__PURE__ */ new Set(["CodeMirror-linenumbers", "CodeMirror-foldgutter", ...((N = t.options) == null ? void 0 : N.gutters) || []])]
    }), d = X(), c = t.name || ((F = (V = d == null ? void 0 : d.parent) == null ? void 0 : V.type) == null ? void 0 : F.name) || void 0, p = x(null), a = I(() => {
      var i;
      return t.merge ? (i = k(s)) == null ? void 0 : i.editor() : k(s);
    }), { refresh: m, resize: v, destroy: y, containerHeight: C, containerWidth: U, reviseStyle: W } = Me({
      props: t,
      cminstance: s,
      presetRef: p
    }), { listenerEvents: G } = Ce({
      props: t,
      cminstance: s,
      emit: o,
      internalInstance: d,
      content: l
    }), D = () => {
      t.unseenLines !== void 0 && t.marker !== void 0 && t.unseenLines.forEach((i) => {
        var h, w;
        const f = (h = s.value) == null ? void 0 : h.lineInfo(i);
        (w = s.value) == null || w.setGutterMarker(i, "breakpoints", f != null && f.gutterMarkers ? null : t.marker());
      });
    }, J = (i) => {
      var h, w;
      const f = (h = s.value) == null ? void 0 : h.getValue();
      i !== f && ((w = s.value) == null || w.setValue(i), l.value = i, W()), D();
    }, Z = () => {
      G(), D(), v(t.width, t.height), o("ready", s.value), $(
        [() => t.width, () => t.height],
        ([i, f]) => {
          v(i, f);
        },
        { deep: !0 }
      );
    }, q = () => {
      if (t.options.mode === "fclog" || t.options.mode === "log") {
        g.value = xe;
        return;
      }
      if (t.merge) {
        g.value = pe;
        return;
      }
      g.value = z;
    };
    return $(
      () => t.options,
      (i) => {
        var f;
        for (const h in t.options)
          (f = a.value) == null || f.setOption(h, k(i[h]));
      },
      { deep: !0 }
    ), $(
      () => t.value,
      (i) => {
        J(i);
      }
    ), $(() => t.merge, q, { immediate: !0 }), Y(() => {
      y();
    }), n({
      cminstance: s,
      resize: v,
      refresh: m,
      destroy: y
    }), (i, f) => (b(), E("div", {
      class: ee(["codemirror-container", {
        merge: i.$props.merge,
        bordered: i.$props.border || i.$props.merge && !t.originalStyle,
        "original-style": t.originalStyle
      }]),
      style: te({
        height: k(C),
        width: k(U)
      })
    }, [
      (b(), ne(oe(g.value), re({
        ref_key: "presetRef",
        ref: p,
        cminstance: s.value,
        "onUpdate:cminstance": f[0] || (f[0] = (h) => s.value = h),
        style: { height: "100%" }
      }, {
        ...i.$props,
        ...i.$attrs,
        options: u.value,
        name: k(c),
        content: l.value
      }, { onReady: Z }), null, 16, ["cminstance"]))
    ], 6));
  }
}), P = (e, n) => (n && n.options && (H.props.globalOptions.default = () => n.options), e.component((n == null ? void 0 : n.componentName) || "Codemirror", H), e), Pe = window.CodeMirror || _, Ue = P, We = P;
function styleInject(css,ref){if(ref===void 0){ref={}}var insertAt=ref.insertAt;if(!css||typeof document==="undefined"){return}var head=document.head||document.getElementsByTagName("head")[0];var style=document.createElement("style");style.type="text/css";if(insertAt==="top"){if(head.firstChild){head.insertBefore(style,head.firstChild)}else{head.appendChild(style)}}else{head.appendChild(style)}if(style.styleSheet){style.styleSheet.cssText=css}else{style.appendChild(document.createTextNode(css))}};styleInject(`.codemirror-container {
  position: relative;
  display: inline-block;
  height: 100%;
  width: fit-content;
  font-size: 13px;
  overflow: hidden;
}
.codemirror-container.bordered {
  border: 1px solid #aaaaaa;
}

.codemirror-container .editor_custom_link {
  cursor: pointer;
  color: #1474f1;
  text-decoration: underline;
}
.codemirror-container .editor_custom_link:hover {
  color: #04b4fa;
}
.codemirror-container:not(.original-style) .CodeMirror-lines .CodeMirror-placeholder.CodeMirror-line-like {
  color: #666;
}
.codemirror-container:not(.original-style) .CodeMirror,
.codemirror-container:not(.original-style) .CodeMirror-merge-pane {
  height: 100%;
  font-family: consolas !important;
}
.codemirror-container:not(.original-style) .CodeMirror-merge,
.codemirror-container:not(.original-style) .CodeMirror-merge-right .CodeMirror {
  height: 100%;
  border: none !important;
}
.codemirror-container:not(.original-style) .c-editor--log__error {
  color: #bb0606;
  font-weight: bold;
}
.codemirror-container:not(.original-style) .c-editor--log__info {
  color: #333333;
  font-weight: bold;
}
.codemirror-container:not(.original-style) .c-editor--log__warning {
  color: #ee9900;
}
.codemirror-container:not(.original-style) .c-editor--log__success {
  color: #669600;
}
.codemirror-container:not(.original-style) .cm-header,
.codemirror-container:not(.original-style) .cm-strong {
  font-weight: bold;
}
`);
export {
  Pe as CodeMirror,
  Ue as GlobalCmComponent,
  We as InstallCodemirro,
  H as VueCodemirror,
  ze as createLinkMark,
  Re as createLog,
  He as createLogMark,
  Be as createTitle,
  H as default,
  fe as getLinkMarks,
  ge as getLocalTime,
  he as getLogMark,
  me as logErrorType
};
